#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "iao_comm.h"
#include "iao_http.h"

#ifdef WIN32
#pragma warning(disable : 4996)
#endif 

static int geturl(iao_http_channel *channel, char *host, int port, int secure,  char *resource,
		 char **data, char *proxyhost, int proxyport, char *proxycridentials)
{
	int ret;

	if (proxyhost!=NULL)
	{
		ret = iao_http_proxy_open(host, port, secure, proxyhost, proxyport,
                              proxycridentials, channel);
	}
	else
	{
		ret = iao_http_open(host, port, secure, channel);
	}
	if (ret==0)
	{
		if ( (ret = iao_http_get(channel, resource))==0)
		{
			ret = iao_http_getpage(channel, data);
		}
		iao_http_close(channel);
	}
	return ret;
}

static char *parseadvance(char *haystack, char *needle)
{
	int len = (int)strlen(needle);
	if (strncmp(haystack, needle, len)==0)
	{
		return haystack + len;
	}
	else
	{
		return NULL;
	}
}

static void getbetween(char *buff, char *p1, char *p2)
{
	int len = (int)(p2 - p1);
	strncpy(buff, p1, len);
	buff[len]=0;
}

int iao_geturlproxy(iao_http_channel *channel, char *url, char **data, char *proxyhost, 
                    int proxyport, char *proxycridentials)
{
	char *http = "http://";
	char *https = "https://";
	char *p;
	char *colon,*slash;
	char host[1024];
	int port = 80;
	char resource[1024];
	int secure=0;

	p = parseadvance(url, https);
	if (p!=NULL)
	{
		secure = 1;
		port=443;
	}
	else
	{
		p = parseadvance(url, http);
		if (p==NULL)
		{
			p = url;
		}
	}

	colon = strstr(p, ":");
	slash = strstr(p, "/");

	if (colon!=NULL && slash!=NULL && colon>slash)
	{
		colon = NULL;
	}

	if (colon!=NULL)
	{
		port = atoi(colon+1);
	}

	if (slash!=NULL)
	{
		strcpy(resource, slash);
		if (colon!=NULL)
		{
			getbetween(host, p, colon);
		}
		else
		{
			getbetween(host, p, slash);
		}
	}
	else
	{
		strcpy(resource, "/");
		if (colon!=NULL)
		{
			getbetween(host, p, colon);
		}
		else
		{
			strcpy(host, p);
		}
	}

	return geturl(channel, host, port, secure, resource, data, proxyhost, proxyport, proxycridentials);
}

int iao_geturl(iao_http_channel *channel, char *url, char **data)
{
	return iao_geturlproxy(channel, url, data, NULL, -1, NULL);
}
/*
char *agentname() 
{
	return "testagent";
}
int main(int argc, char *argv[])
{
	char *data;
	iao_http_channel http;
	int ret;
	char *url = argc<=1?"http://asdfasdf:23/samba/dibana.html":argv[1];
	
	iao_tcpinit();
	ret = iao_geturl(&http, url, &data);

	printf("\nret = %d\nstatuscode = %d\nstatus = %s\nstatus2 =  %s\n", ret, http.statuscode, http.status, iao_http_status(http.statuscode)); 
	if (ret>0)
	{
		data[100]=0;
		printf("%s\n", data);
		free(data);
	}
	return 0;
}*/
