#ifndef __DIR_H
#define __DIR_H

#ifdef WIN32
typedef __int64 int64;
#else
#include <sys/types.h>
typedef __int64_t int64;
#endif

#define MAX_FILENAME_LEN 512

typedef void *dirhandle;
typedef struct {
	int isdir;
	int64 size;
	char name[MAX_FILENAME_LEN];
} fileinfo;

dirhandle opendirhandle(char *path);
int nextfile(dirhandle d, fileinfo *fi);
void closedirhandle(dirhandle d);

int getfileinfo(char *path, fileinfo *fi);

#endif
